Set          c  colors               

Set          bb       batches       

             b(bb)  actual batches

Parameter    nc number of colors     

             mincb(c,bb) minimum balls of colors placed

Scalar       nb number of batches

;



$gdxin batchin.gdx

$load c bb b nc mincb



nb = card(b);



Variable   z                objective variable

           x(c,bb)          number of balls of color c in batch

           p(c,bb), n(c,bb) positive and negative part of deviation

Integer Variable x;

Positive Variable p,n;



Equation havecol(c)  balls in all batches add up

         defpm(c,bb) deviation

         defobj      objective;



havecol(c)$nc(c).. sum(b, x(c,b)) =e= nc(c);

defpm(c,b)$nc(c).. p(c,b) - n(c,b) =e= nc(c)/nb - x(c,b);

defobj..           z =e= sum((c,b),p(c,b)+n(c,b));



model batch /all/;

batch.optcr=0; option mip=cplex;

x.up(c,b) = nc(c);

x.lo(c,b) = mincb(c,b);



solve batch minimizing z using mip;



Parameter ba(bb,c) batch assignment;

ba(b,c) = round(x.l(c,b));

Scalar zobj; zobj = z.l;



display ba;