$Title cc.gms Driver for different models/algorithms to solve the ISCI problem

$ontext

This model computes an optimal or near optimal schedule for the ISCI problem:

Major advertisers purchase several slots to air commercials during a given time
period on a broadcast network.  We study the problem of scheduling advertiser's
commercials in the slots it purchased when the same commercial is to be aired
multiple times.  Under such a situation, the advertisers typically want the
airings of a commercial to be as much evenly spaced as possible.


Following options are possible:

curid       - Identifier of the problem instance (0-40)
alg         - Algorithm/Model used to solve instance:
                p2    GAMS/CPLEX P2
                p3    GAMS/CPLEX P3
                d3    P3/Delta Heuristic
                b3    P3/Batching Heuristic
                ah    Assignment Heuristic
resmax      - Maximum time available to solve the instance
preplaced   - use instance with preplaced balls (not available with alg=ah)

$offtext

$if not set alg    $set resmax b3
$if not set curid  $set curid  1
$if not set resmax $set resmax 600

$if not set preplaced $call =gams ccx --curid=%curid% --alg=%alg% --resmax=%resmax% 
$if     set preplaced $call =gams ccx --curid=%curid% --alg=%alg% --resmax=%resmax% --prefix=yes


