Set       s slots
          c colors             
Parameter d(c) number of colors
          dc(c)    ideal distance; 

$gdxin col.gdx
$load s c d dc
 
Parameter r(c) ratio;
Scalar    n;

n = sum(c,d(c));
r(c) = d(c)/n;

alias (s,j);
Set ij(c,j); ij(c,j) = ord(j) <= d(c);

parameter cost(c,j,s), Z(c,j) /
$include pos.txt
/
; 

cost(ij(c,j),s)$(Z(c,j) - 50 <= ord(s) and ord(s) <= Z(c,j) + 50) =
          sqr(ord(s) - Z(c,j)) + 1;
*           abs(ord(s) - Z(c,j)) + 1;

set ijk(c,j,s); ijk(ij(c,j),s)$cost(c,j,s) = yes;

binary variable x(c,j,s);
variable obj;

equation defobj
         assign1, assign2;

defobj.. obj =e= sum(ijk, (cost(ijk)-1)*x(ijk));
assign1(s).. sum(ijk(c,j,s), x(ijk)) =e= 1;
assign2(ij).. sum(ijk(ij,s), x(ijk)) =e= 1;
          
model assign /all/;
option mip=cplex;
solve assign min obj using mip;

*option x:0:0:1;
*display x.l;
scalar newpos,lastpos,sobj /0/;
file fsol / fsol.txt /;

$ontext
loop(c$d(c),
  lastpos = smin(ijk(c,j,s)$round(x.l(ijk)), ord(s));
  while (lastpos <= n, 
    put fsol (lastpos-1):0:0 '.' c.tl:0:0 /;
    newpos = smin(ijk(c,j,s)$(round(x.l(ijk)) and ord(s)>lastpos), ord(s));
    sobj$(newpos <= n) = sobj + abs(newpos-lastpos-dc(c));
    lastpos = newpos;
  )
);
$offtext

*$ontext
scalar i1 ord of s,i2 lastpos ,i3 error ,i4 ord c;

loop(c$d(c),
  lastpos = smin(ijk(c,j,s)$round(x.l(ijk)), ord(s));
  put fsol (lastpos-1):0:0 '.' c.tl:0:0 /;
  loop(ijk(c,j,s)$(ord(j)>1 and round(x.l(ijk))), 
    put fsol (ord(s)-1):0:0 '.' c.tl:0:0 /;
    abort$(lastpos>ord(s)) 'stop';
    sobj = sobj + abs(ord(s)-lastpos-dc(c));
    lastpos = ord(s);
  )
)
*$offtext
putclose fsol;

$onecho > rfsol.gms
set sa(*,*) /
$include fsol.txt
/;
$offecho
execute '=gams rfsol gdx=solveout%curid%';

display sobj;

parameter rep;
rep(s,c) = round(sum(ijk(c,j,s),x.l(ijk)));
display rep;
