Set         sp slots plus initial
            rank rank of ball
            s(sp) slots            
            c colors
            pp(sp,c) pre placed balls 
            rc(rank,c) rank color mapping
Scalar      n number of commercial
            rlim time limit
            rusd time used
Parameter   nc(c)    number of colors
            dc(c)    ideal distance; 

$gdxin solvein.gdx
$load sp rank=sp c nc pp dc rlim

n = sum(c,nc(c));
rc(rank,c)$(ord(rank)<=nc(c)) = yes;
s(sp)     $(ord(sp)  <= n)    = yes;

display nc,rc;
* Model
Variable z(rank,c)    slot number of ball of rank
         y(rank,c,sp) rank ball of color assigned to slot
         obj          objective varibale
         xp(rank,c),xm(rank,c) postitive and negative part of absolute function
;

Binary variable y;
Integer variable z;
Positive variables xp, xm;

Equation order(rank,c)  ranks are ordered
         colreq(c)      number of ball of a color assigned
         defZ(rank,c)   definition of Z
         covslot(sp)    slot cover requirement
         covrank(rank,c) rank cover requirement
         fix(sp,c)      fixed slot
         defpm(rank,c)  absoulte value definition
         defobj         objective function;

order(rc(rank+1,c))..  
         z(rank,c) =l= z(rank+1,c) - 1;

colreq(c)$nc(c)..
         sum((rc(rank,c),s),y(rc,s)) =e= nc(c);

defZ(rc)..
         z(rc) =e= sum(s(sp), ord(sp)*y(rc,s));

covslot(s)..
         sum(rc, y(rc,s)) =e= 1;

covrank(rc)..
         sum(s, y(rc,s)) =e= 1;

fix(pp(sp,c)).. 
         sum(rc(rank,c), y(rc,sp-1)) =e= 1;

defpm(rc(rank+1,c))..
         xp(rank,c) - xm(rank,c) =e= z(rank+1,c) - z(rank,c) - dc(c);

defobj.. obj =e= sum(rc(rank+1,c), xp(rank,c) + xm(rank,c));

model p2 /all/;
option optcr=0, mip=cplex, iterlim=10000000;

p2.reslim = rlim;
z.up(rc) = n;
p2.optfile = 1;
$echo mipemphasis 1 > cplex.opt
$echo startalg 4   >> cplex.opt

Set sa(sp,c) slot assignment;

$if not exist solveout%curid%.gdx $goto skiplint
$gdxin solveout%curid%
$load sa
$echo mipstart 1   >> cplex.opt

display sa;

scalar cnt /0/;
loop(c,
  cnt = 0;
  loop(sa(sp,c),
    cnt = cnt + 1;
    y.l(rc(rank,c),sp)$(ord(rank)=cnt) = 1;
  )
);
z.l(rc) = sum(s(sp), ord(sp)*y.l(rc,s));

display y.l, z.l;
$label skiplint

solve p2 min obj using mip;

abort$(p2.modelstat <> 1 and p2.modelstat <> 8) 'solvep2 did not return a solution';

sa(s,c) = sum(rc(rank,c),round(y.l(rc,s)));

Scalar sobj; sobj = obj.l;
Scalar bnd;  bnd  = p2.objest; rusd = p2.resusd;

display sa;
